// simulated annealing
// 
import java.io.*;
import javax.swing.JOptionPane;


class fa extends f_xj
{
//çözümü istenen fonksiyon	
 double func(double x[])
 {
    double ff= 21.5+x[0]*Math.sin(4.0*Math.PI*x[0])+x[1]*Math.sin(20.0*Math.PI*x[1]);
    return ff; //maksimum testi
}
}

class fb extends f_xj
{
public double func(double x[]) 
{
//çözümü istenen fonksiyon
// newton metodu minimumaçalışıyor bu yüzden 
//- işaretitanımladık.	
double ff;
fa fx=new fa();
return -fx.func(x); //maksimum testi
}
}

class OPO21
{
    public static void main(String args[]) throws IOException
    {
    int N=18;
	int POPSIZE=1;
    int MAXGENS=400;
    int NVARS=2;
    fa fax=new fa();
    fb fbx=new fb();
    simulatedannealing xx=new simulatedannealing(POPSIZE,NVARS,N,20);
    double low[]=new double[NVARS];
    double high[]=new double[NVARS];
    low[0]=-3.0;high[0]=12.1;
    low[1]=4.1;high[1]=5.8;
    double a[]=xx.calculate(low,high,fax,true);
    double x0[]=new double[NVARS];
    for(int i=0;i<NVARS;i++) x0[i]=a[i];
    String s="simulated annealing (tavlama simulasyonu)metodu sonucu =\n"+Matrix.toStringT(a);
    double [] r1= opt.newtond(fbx,x0);
    double ff1=-fbx.func(r1);
     s+="newton çözüm seti  : \n"+Matrix.toStringT(r1)+ff1;
     String s2="simulated annealing ve newton çok değişkenli fonksiyon optimizasyonun birlikte kullanımı:";
     JOptionPane.showMessageDialog(null,s,s2,JOptionPane.PLAIN_MESSAGE);     
    }
}
